/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.44 from the
 * contents of Sentinel.xs. Do not edit this file, edit Sentinel.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Sentinel.xs"
/*  You may distribute under the terms of either the GNU General Public License
 *  or the Artistic License (the same terms as Perl itself)
 *
 *  (C) Paul Evans, 2011 -- leonerd@leonerd.org.uk
 */

#define PERL_NO_GET_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifndef G_METHOD_NAMED
#define G_METHOD_NAMED G_METHOD
#endif

#include <string.h>
#define streq(a,b) (strcmp((a),(b)) == 0)

enum {
  CTX_GET_CB,
  CTX_SET_CB,
  CTX_OBJ,
};

typedef SV *sentinel_ctx;

static int magic_get(pTHX_ SV *sv, MAGIC *mg)
{
  dSP;
  sentinel_ctx *ctx = (sentinel_ctx*)AvARRAY(mg->mg_obj);

  if(ctx[CTX_GET_CB]) {
    int count;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    if(ctx[CTX_OBJ]) {
      EXTEND(SP, 1);
      PUSHs(ctx[CTX_OBJ]);
    }
    PUTBACK;

    if(ctx[CTX_OBJ] && SvPOK(ctx[CTX_GET_CB]))
      // Calling method by name
      count = call_sv(ctx[CTX_GET_CB], G_SCALAR | G_METHOD_NAMED);
    else
      count = call_sv(ctx[CTX_GET_CB], G_SCALAR);
    assert(count == 1);

    SPAGAIN;
    sv_setsv_nomg(sv, POPs);

    PUTBACK;
    FREETMPS;
    LEAVE;
  }

  return 1;
}

static int magic_set(pTHX_ SV *sv, MAGIC *mg)
{
  dSP;
  sentinel_ctx *ctx = (sentinel_ctx*)AvARRAY(mg->mg_obj);

  if(ctx[CTX_SET_CB]) {
    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    if(ctx[CTX_OBJ]) {
      EXTEND(SP, 2);
      PUSHs(ctx[CTX_OBJ]);
    }
    else {
      EXTEND(SP, 1);
    }
    PUSHs(sv);
    PUTBACK;

    if(ctx[CTX_OBJ] && SvPOK(ctx[CTX_SET_CB]))
      // Calling method by name
      call_sv(ctx[CTX_SET_CB], G_VOID | G_METHOD_NAMED);
    else
      call_sv(ctx[CTX_SET_CB], G_VOID);

    FREETMPS;
    LEAVE;
  }

  return 1;
}

static MGVTBL vtbl = {
  &magic_get,
  &magic_set,
};

#line 112 "lib/Sentinel.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 256 "lib/Sentinel.c"

XS_EUPXS(XS_Sentinel_sentinel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sentinel_sentinel)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 107 "lib/Sentinel.xs"
    int i;
    SV *value = NULL;
    SV *get_cb = NULL;
    SV *set_cb = NULL;
    SV *obj = NULL;
    SV *retval;

#line 275 "lib/Sentinel.c"
	SV *	RETVAL;
#line 115 "lib/Sentinel.xs"
    /* Parse name => value argument pairs */
    for(i = 0; i < items; i += 2) {
      char *argname  = SvPV_nolen(ST(i));
      SV   *argvalue = ST(i+1);

      if(streq(argname, "value")) {
        value = argvalue;
      }
      else if(streq(argname, "get")) {
        get_cb = argvalue;
      }
      else if(streq(argname, "set")) {
        set_cb = argvalue;
      }
      else if(streq(argname, "obj")) {
        obj = argvalue;
      }
      else {
        fprintf(stderr, "Argument %s at %p\n", argname, argvalue);
      }
    }

    retval = sv_newmortal();
/**
 * Perl 5.14 allows any TEMP scalar to be returned in LVALUE context provided
 * it is magical. Perl versions before this only accept magic for being a tied
 * array or hash element. Rather than try to hack this magic type, we'll just
 * pretend the SV isn't a TEMP
 * The following workaround is known to work on Perl 5.12.4.
 */
#if (PERL_REVISION == 5) && (PERL_VERSION < 14)
    SvFLAGS(retval) &= ~SVs_TEMP;
#endif

    if(value)
      sv_setsv(retval, value);

    if(get_cb || set_cb) {
      sentinel_ctx *ctx;
      AV* payload = newAV();
      av_extend(payload, 2);
      AvFILLp(payload) = 2;

      ctx = (sentinel_ctx*)AvARRAY(payload);

      ctx[CTX_GET_CB] = get_cb ? newSVsv(get_cb) : NULL;
      ctx[CTX_SET_CB] = set_cb ? newSVsv(set_cb) : NULL;
      ctx[CTX_OBJ] = obj ? newSVsv(obj) : NULL;

      sv_magicext(retval, (SV*)payload, PERL_MAGIC_ext, &vtbl, NULL, 0);
      SvREFCNT_dec(payload);
    }

    if (!items)
      EXTEND(SP, 1);
    PUSHs(retval);
    XSRETURN(1);
#line 335 "lib/Sentinel.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Sentinel); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Sentinel)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Sentinel::sentinel", XS_Sentinel_sentinel);

    /* Initialisation Section */

#line 174 "lib/Sentinel.xs"
  CvLVALUE_on(get_cv("Sentinel::sentinel", 0));

#line 376 "lib/Sentinel.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

